﻿//////////////////////////////////////////////
// GlesErrorChecker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// Standards
#include <functional>
#include <string_view>

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesErrorChecker
	{
		private :

			// Attributes
			static std::function<void ()> _callback ;
			static bool _debugEnabled ;

		private :

			// Functions
			// Constructor, destructor
			GlesErrorChecker () = delete ;
			~GlesErrorChecker () = delete ;

		public :

			// Setters
			static void setCallback (const std::function<void ()>& value) ;
			static void setDebugEnabled (bool value) ;

			// Check
			static bool checkForError (const std::string_view& operationDesc) ;
	} ;
}