﻿//////////////////////////////////////////////
// Gl4FunctionRepository.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// Gl
#include <opengl/glcorearb.h>

/// Class ------------------------------------

namespace nkGraphics::gles
{
	// Buffers
	extern PFNGLBINDBUFFERPROC glBindBuffer ;
	extern PFNGLBINDBUFFERBASEPROC glBindBufferBase ;
	extern PFNGLBINDBUFFERRANGEPROC glBindBufferRange ;
	extern PFNGLBUFFERDATAPROC glBufferData ;
	extern PFNGLDELETEBUFFERSPROC glDeleteBuffers ;
	extern PFNGLGENBUFFERSPROC glGenBuffers ;

	// Clear
	extern PFNGLCLEARCOLORPROC glClearColor ;
	extern PFNGLCLEARPROC glClear ;

	// Draw
	extern PFNGLDRAWELEMENTSINSTANCEDPROC glDrawElementsInstanced ;

	// Framebuffers
	extern PFNGLBINDFRAMEBUFFERPROC glBindFramebuffer ;
	extern PFNGLDELETEFRAMEBUFFERSPROC glDeleteFramebuffers ;
	extern PFNGLFRAMEBUFFERTEXTURE2DPROC glFramebufferTexture2D ;
	extern PFNGLGENFRAMEBUFFERSPROC glGenFramebuffers ;

	// Global
	extern PFNGLDEBUGMESSAGECALLBACKPROC glDebugMessageCallback ;
	extern PFNGLDISABLEPROC glDisable ;
	extern PFNGLENABLEPROC glEnable ;
	extern PFNGLGETERRORPROC glGetError ;

	// Meshes
	extern PFNGLDISABLEVERTEXATTRIBARRAYPROC glDisableVertexAttribArray ;
	extern PFNGLENABLEVERTEXATTRIBARRAYPROC glEnableVertexAttribArray ;
	extern PFNGLVERTEXATTRIBPOINTERPROC glVertexAttribPointer ;

	// Programs
	extern PFNGLATTACHSHADERPROC glAttachShader ;
	extern PFNGLCOMPILESHADERPROC glCompileShader ;
	extern PFNGLCREATEPROGRAMPROC glCreateProgram ;
	extern PFNGLCREATESHADERPROC glCreateShader ;
	extern PFNGLDELETEPROGRAMPROC glDeleteProgram ;
	extern PFNGLDELETESHADERPROC glDeleteShader ;
	extern PFNGLGETACTIVEUNIFORMPROC glGetActiveUniform ;
	extern PFNGLGETPROGRAMINFOLOGPROC glGetProgramInfoLog ;
	extern PFNGLGETPROGRAMIVPROC glGetProgramiv ;
	extern PFNGLGETSHADERINFOLOGPROC glGetShaderInfoLog ;
	extern PFNGLGETSHADERIVPROC glGetShaderiv ;
	extern PFNGLGETUNIFORMBLOCKINDEXPROC glGetUniformBlockIndex ;
	extern PFNGLLINKPROGRAMPROC glLinkProgram ;
	extern PFNGLSHADERSOURCEPROC glShaderSource ;
	extern PFNGLUNIFORMBLOCKBINDINGPROC glUniformBlockBinding ;
	extern PFNGLUSEPROGRAMPROC glUseProgram ;

	// Textures
	extern PFNGLBINDTEXTUREPROC glBindTexture ;
	extern PFNGLDELETETEXTURESPROC glDeleteTextures ;
	extern PFNGLGENTEXTURESPROC glGenTextures ;
	extern PFNGLTEXIMAGE2DPROC glTexImage2D ;
	extern PFNGLTEXPARAMETERIPROC glTexParameteri ;
	extern PFNGLTEXSTORAGE2DPROC glTexStorage2D ;

	// Viewports
	extern PFNGLVIEWPORTPROC glViewport ;
}