﻿//////////////////////////////////////////////
// GlesMesh.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics::gles
{
	class GlesBuffer ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../../Meshes/Mesh.h"

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesMesh : public Mesh
	{
		private :

			// Attributes
			// Data buffers
			GlesBuffer* _vertexBuffer ;
			GlesBuffer* _indexBuffer ;

			unsigned int _bufferStride ;

		private :

			// Functions
			void _fillGpuBuffers () ;

		public :

			// Constructor, destructor
			GlesMesh () ;
			~GlesMesh () ;

			// Getters
			GlesBuffer* getVertexBuffer () const ;
			GlesBuffer* getIndexBuffer () const ;
			unsigned int getBufferStride () const ;

			// Geometry stream
			virtual void prepareForGeometryStream () override ;

			// Loading
			virtual bool load () override ;
			virtual void unload () override ;
	} ;
}