﻿//////////////////////////////////////////////
// GlesRenderQueue.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics::gles
{
	class GlesShader ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../../RenderQueues/RenderQueue.h"

#include "GlesQueueShaderHistory.h"

// Standards
#include <unordered_map>

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesRenderQueue final : public RenderQueue
	{
		private :

			// Attributes
			std::unordered_map<GlesShader*, GlesQueueShaderHistory> _usedShaders ;

		public :

			// Constructor, destructor
			GlesRenderQueue () ;
			~GlesRenderQueue () ;

			// Rendering
			void render (GlesShader* shade = nullptr, bool transparent = false) ;
	} ;
}