﻿//////////////////////////////////////////////
// GlesBlendState.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../../RenderStates/BlendState.h"

/// Class ------------------------------------
	
namespace nkGraphics::gles
{
	class GlesBlendState final : public BlendState
	{		
		public :
		
			// Constructor, destructor
			GlesBlendState () ;
			~GlesBlendState () ;

			// Getters
			virtual bool getAlphaToCoverageEnabled () const override ;
			virtual bool getIndependantBlendEnabled () const override ;
			virtual bool getTargetBlendEnabled (unsigned int targetId = 0) const override ;
			virtual BLEND getTargetSrcBlend (unsigned int targetId = 0) const override ;
			virtual BLEND getTargetDestBlend (unsigned int targetId = 0) const override ;
			virtual BLEND_OP getTargetBlendOp (unsigned int targetId = 0) const override ;
			virtual BLEND getTargetSrcBlendAlpha (unsigned int targetId = 0) const override ;
			virtual BLEND getTargetDestBlendAlpha (unsigned int targetId = 0) const override ;
			virtual BLEND_OP getTargetBlendOpAlpha (unsigned int targetId = 0) const override ;
			virtual COLOR_WRITE_ENABLE getTargetWriteMask (unsigned int targetId = 0) const override ;

			// Setters
			virtual void setAlphaToCoverageEnabled (bool value) override ;
			virtual void setIndependentBlendEnabled (bool value) override ;
			virtual void setTargetBlendEnable (bool value, unsigned int targetId = 0) override ;
			virtual void setTargetSrcBlend (BLEND type, unsigned int targetId = 0) override ;
			virtual void setTargetDestBlend (BLEND type, unsigned int targetId = 0) override ;
			virtual void setTargetBlendOp (BLEND_OP type, unsigned int targetId = 0) override ;
			virtual void setTargetSrcBlendAlpha (BLEND type, unsigned int targetId = 0) override ;
			virtual void setTargetDestBlendAlpha (BLEND type, unsigned int targetId = 0) override ;
			virtual void setTargetBlendOpAlpha (BLEND_OP type, unsigned int targetId = 0) override ;
			virtual void setTargetWriteMask (COLOR_WRITE_ENABLE mask, unsigned int targetId = 0) override ;
			void resetToDefault () ;			

			// Loading
			virtual bool load () override ;
			virtual void unload () override ;

			// Activation
			void activate () ;
	} ;
}