﻿//////////////////////////////////////////////
// GlesDepthStencilState.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

struct D3D11_DEPTH_STENCIL_DESC ;
struct ID3D11DepthStencilState ;

/// Includes ---------------------------------

// nkGraphics
#include "../../../RenderStates/DepthStencilState.h"

/// Class ------------------------------------
	
namespace nkGraphics::gles
{
	class GlesDepthStencilState final : public DepthStencilState
	{		
		public :
		
			// Constructor, destructor
			GlesDepthStencilState () ;
			~GlesDepthStencilState () ;

			// Getters depth
			virtual bool getDepthEnabled () const override ;
			virtual DEPTH_WRITE_MASK getDepthMasking () const override ;
			virtual COMPARISON_FUNC getDepthComparison() const override ;
			// Getters Stencil
			virtual bool getStencilEnabled () const override ;
			virtual unsigned char getStencilReadMask () const override ;
			virtual unsigned char getStencilWriteMask () const override ;
			virtual STENCIL_OP getStencilFailFrontFace () const override ;
			virtual STENCIL_OP getStencilOkDepthFailFrontFace () const override ;
			virtual STENCIL_OP getStencilDepthOkFrontFace () const override ;
			virtual COMPARISON_FUNC getStencilComparisonFrontFace () const override ;
			virtual STENCIL_OP getStencilFailBackFace () const override ;
			virtual STENCIL_OP getStencilOkDepthFailBackFace () const override ;
			virtual STENCIL_OP getStencilDepthOkBackFace () const override ;
			virtual COMPARISON_FUNC getStencilComparisonBackFace () const override ;

			// Setters global
			virtual void resetToDefault () ;
			// Setters Depth
			virtual void setDepthEnabled (bool value) override ;
			virtual void setDepthMasking (DEPTH_WRITE_MASK value) override ;
			virtual void setDepthComparison (COMPARISON_FUNC value) override ;
			// Setters Stencil
			virtual void setStencilEnabled (bool value) override ;
			virtual void setStencilReadMask (unsigned char value) override ;
			virtual void setStencilWriteMask (unsigned char value) override ;
			virtual void setStencilFailFrontFace (STENCIL_OP value) override ;
			virtual void setStencilOkDepthFailFrontFace (STENCIL_OP value) override ;
			virtual void setStencilDepthOkFrontFace (STENCIL_OP value) override ;
			virtual void setStencilComparisonFrontFace (COMPARISON_FUNC value) override ;
			virtual void setStencilFailBackFace (STENCIL_OP value) override ;
			virtual void setStencilOkDepthFailBackFace (STENCIL_OP value) override ;
			virtual void setStencilDepthOkBackFace (STENCIL_OP value) override ;
			virtual void setStencilComparisonBackFace (COMPARISON_FUNC value) override ;

			// Loading
			virtual bool load () override ;
			virtual void unload () override ;

			// Activation
			void activate () ;
	} ;
}