﻿//////////////////////////////////////////////
// GlesRasterState.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

struct D3D11_RASTERIZER_DESC ;
struct ID3D11RasterizerState ;

/// Includes ---------------------------------

// nkGraphics
#include "../../../RenderStates/RasterState.h"

/// Class ------------------------------------
	
namespace nkGraphics::gles
{
	class GlesRasterState final : public RasterState
	{		
		public :
		
			// Constructor, destructor
			GlesRasterState () ;
			~GlesRasterState () ;

			// Getters
			virtual FILL_MODE getFillMode () const override ;
			virtual CULL_MODE getCullMode () const override ;
			virtual bool getFrontCounterClockwise () const override ;
			virtual int getDepthBias () const override ;
			virtual float getDepthBiasClamp () const override ;
			virtual float getSlopeScaledDepthBias () const override ;
			virtual bool getDepthClipEnabled () const override ;
			virtual bool getScissorEnabled () const override ;
			virtual bool getMultiSampleEnabled () const override ;
			virtual bool getAntiAliasedLineEnabled () const override ;
			virtual unsigned int getForcedSampleCount () const override ;
			virtual bool getConservativeRasterizationEnabled () const override ;

			// Setters
			virtual void setFillMode (FILL_MODE value) override ;
			virtual void setCullMode (CULL_MODE value) override ;
			virtual void setFrontCounterClockwise (bool value) override ;
			virtual void setDepthBias (int value) override ;
			virtual void setDepthBiasClamp (float value) override ;
			virtual void setSlopeScaledDepthBias (float value) override ;
			virtual void setDepthClipEnabled (bool value) override ;
			virtual void setScissorEnabled (bool value) override ;
			virtual void setMultiSampleEnabled (bool value) override ;
			virtual void setAntiAliasedLineEnabled (bool value) override ;
			virtual void setForcedSampleCount (unsigned int value) override ;
			virtual void setConservativeRasterizationEnabled (bool value) override ;
			virtual void resetToDefault () override ;

			// Loading
			virtual bool load () override ;
			virtual void unload () override ;

			// Activation
			void activate () ;
	} ;
}