﻿//////////////////////////////////////////////
// GlesSampler.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../../Samplers/Sampler.h"

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesSampler : public Sampler
	{
		public :

			// Constructor, destructor
			GlesSampler () ;
			~GlesSampler () ;

			// Getters
			virtual FILTER getFiltering () const override ;
			virtual TEXTURE_ADDRESS_MODE getAddressModeU () const override ;
			virtual TEXTURE_ADDRESS_MODE getAddressModeV () const override ;
			virtual TEXTURE_ADDRESS_MODE getAddressModeW () const override ;
			virtual COMPARISON_FUNC getComparisonFunc () const override ;
			virtual float getMipBias () const override ;
			virtual unsigned int getMaxAnisotropy () const override ;
			virtual float getMinLodLevel () const override ;
			virtual float getMaxLodLevel () const override ;
			virtual float getBorderColorR () const override ;
			virtual float getBorderColorG () const override ;
			virtual float getBorderColorB () const override ;
			virtual float getBorderColorA () const override ;

			// Setters
			virtual void setBorderColors (float r, float g, float b, float a) override ;
			virtual void setBorderColorR (float value) override ;
			virtual void setBorderColorG (float value) override ;
			virtual void setBorderColorB (float value) override ;
			virtual void setBorderColorA (float value) override ;
			virtual void setLodLevels (float min, float max) override ;
			virtual void setMaxAnisotropy (unsigned int value) override ;
			virtual void setMipMapBias (float value) override ;
			virtual void setFilterMethod (FILTER value) override ;
			virtual void setAddressModeU (TEXTURE_ADDRESS_MODE value) override ;
			virtual void setAddressModeV (TEXTURE_ADDRESS_MODE value) override ;
			virtual void setAddressModeW (TEXTURE_ADDRESS_MODE value) override ;
			virtual void setComparisonFunc (COMPARISON_FUNC value) override ;
			virtual void resetToDefault () override ;

			// Loading
			virtual bool load () override ;
			virtual void unload () override ;
	} ;
}