﻿//////////////////////////////////////////////
// GlesConstantBuffer.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics::gles
{
	class GlesBuffer ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../../../Shaders/Memory/ConstantBuffer.h"

/// Class ------------------------------------

namespace nkGraphics::gles
{
	class GlesConstantBuffer final : public ConstantBuffer
	{
		private :

			// Attributes
			// Memory
			GlesBuffer* _buffer ;
			unsigned char* _refillMemory ;

		private :

			// Functions
			// Allocations
			virtual ShaderPassMemorySlot* allocatePassMemorySlot () override ;
			
		public :

			// Constructor, destructor
			GlesConstantBuffer () ;
			~GlesConstantBuffer () ;

			// Getters
			GlesBuffer* getBuffer () const ;

			// Updates
			void checkBuffer () ;
			void fillBuffer () ;
	} ;
}