﻿//////////////////////////////////////////////
// Quaternion.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkMaths
{
	class Matrix ;
}

/// Includes ---------------------------------

// nkGraphics
#include "Vector.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkMaths
{
	class DLL_MATHS_EXPORT Quaternion : public Vector
	{
		public :
		
			// Constructeur, destructeur
			Quaternion () ;
			Quaternion (float x, float y, float z, float w) ;
			Quaternion (const Vector& axis, float angle) ;
			Quaternion (const Vector& eulerAngles) ;
			Quaternion (const Matrix& mat) ;
			Quaternion (const Quaternion& other) ;
			~Quaternion () ;

			// Pratique
			Vector getAsEulerAngles () const ;

			void setFromAxisAngle (const Vector& axis, float angle) ;
			void setFromEuler (const Vector& angles) ;
			void setFromOrientationMatrix (const Matrix& mat) ;
			void setFromTransformationMatrix (const Matrix& mat) ;

			// Opérators
			// Equality
			Quaternion& operator= (const Quaternion& other) ;
			// Multiplications
			Vector operator* (const Vector& other) const ;
			Quaternion operator* (const Quaternion& other) const ;
			void operator*= (const Quaternion& other) ;
	} ;
}