//////////////////////////////////////////////
// FileExplorer.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"
	
#include "../Dll/DllDefines.h"

// Standards
#include <string>
#include <vector>

/// Class ------------------------------------
		
namespace nkWinUi
{
	class DLL_WINUI_EXPORT FileExplorer : public Component
	{
		public :

			// Conteneur de filtre
			class FileFilter
			{
				public :
						
					// Attributs
					std::string _label ;
					std::string _extension ;

					FileFilter () ;
					FileFilter (const FileFilter& other) ;
					~FileFilter () ;
			} ;

		protected :
		
			// Attributs
			// Concernant les filtres
			std::vector<FileFilter> _filters ;

			char* _filterString ;

			bool _followSelfDir ;
			std::string _currentDir ;
		
		public :
		
			// Constructeur, destructeur
			FileExplorer () ;
			~FileExplorer () ;

			// Filtres
			void addFilter (const std::string_view& label, const std::string_view& extension) ;
			FileFilter& getFilter (unsigned int index) ;
			void setFilter (unsigned int index, const std::string_view& label, const std::string_view& extension) ;

			// Suivi de folder
			void setFollowSelfDir (bool value) ;
			bool getFollowSelfDir () const ;
			void setCurrentDir (const std::string_view& path) ;
			const char* getCurrentDir () const ;

			// Chargement / sauvegarde
			virtual std::string openDialog (bool forSave) = 0 ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}