﻿//////////////////////////////////////////////
// LogWin.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class ScrollBar ;
}

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

// Standards
#include <string>
#include <vector>

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT LogWin : public Component
	{
		protected :
		
			// Attributs
			// Les lignes et le texte
			std::vector<std::string> _lines ;

			// Nombre max de ligne
			unsigned int _maxLine ;

			// L'offset actuel pour s'y retrouver dans le tableau ac' les max lines
			unsigned int _arrayOffset ;

			// La taille d'une ligne en pixels
			unsigned int _lineHeight ;
		
		public :
		
			// Constructeur, destructeur
			LogWin () ;
			~LogWin () ;

			// Getters
			unsigned int getMaxLine () const ;
			virtual const ScrollBar* getVerticalScrollBar () const ;

			// Setters
			void setMaxLine (unsigned int val) ;

			// Manipulation des lignes
			virtual void addLine (const std::string_view& line) ;
			virtual void clear () ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}